################################################################################
# See more in readme.
################################################################################
# Confiugre:
#	Default time to sleep when [second] is not given
	local __much_default_time=1
#	Default time to sleep when using "mya"
	local __much_yaourt_time=4
#	Default zpty name
	local __much_name="much$$"
#	Default zpty tmp file name
	local __much_file="/tmp/much-$USER.$$"
#	Help file position
	local __much_help="$ZSH/plugins/much/readme"
#	Error message
	local __much_error_noarg="Error: At least one argument is needed.\n"
	local __much_error_help="See \"much --help\" for more.\n"
	local __much_error_combine="${__much_error_noarg}${__much_error_help}"
################################################################################

zmodload zsh/zpty

# Is $1 a number?
__much_is_number () {
	expr "$1" "+" 1 &> /dev/null
	if [ $? -eq 0 ]; then
		# It is a number
		return 0
	else
		# It is not a number
		return 1
	fi
}

much () {
	# Is much running on pipe?
	if tty -s <&0; then
	# It is not a pipe
		[ $# -eq 0 ] && printf "$__much_error_combine" && return 1

		[ "$1" = "--help" ] && cat $__much_help && return 0
		[ "$1" = "-h" ] && cat $__much_help && return 0

		if __much_is_number "$1"; then
			# argc[1] is a num, and the argc is 1
			if [ $# -eq 1 ]; then
				sleep "$1"
				return 0
			fi
			# argv[1] is a num, and the argc is 2 more
			local __much_sleeptime="$1"
			shift
		else
			# argv[1] is not a num, and the argc is 2 more
			local __much_sleeptime="$__much_default_time"
		fi

		# Pseudo-terminal to cheat command/program
		zpty "$__much_name" "$@"
		( zpty -r "$__much_name" > "$__much_file" ) &

		sleep "$__much_sleeptime"

		# Display and clean everything
		less -r "$__much_file"
		zpty -d "$__much_name"
		rm -f "$__much_file"
		kill $$

	else
	# It is a pipe
		printf "Sorry, much can not use in pipe now.\n"

		#if [ $# -eq 0 ]; then
			## No argument
			#local __much_sleeptime="$__much_default_time"
		#elif __much_is_number "$1"; then
			## One argument
			#local __much_sleeptime="$1"
		#else
			## Error
			#printf "Just one numerical argument allowed.\n"
		#fi

		#tee | less -r

	fi

	return 0

}

mya () {
	[ $# -eq 0 ] && printf "$__much_error_combine" && return 1
	much "$__much_yaourt_time" yaourt "$@"
	#yaourt "$@"
	return $?
}

alias mls="much ls -lah"
alias much1="much 1"
alias much2="much 2"
alias much3="much 3"
alias much4="much 4"
alias much5="much 5"
alias much6="much 6"
